﻿using Microsoft.AspNetCore.Mvc.Filters;
using System;
using System.Text.Json;

namespace ExternalServiceV3.Attributes
{
   public class BindJson : ActionFilterAttribute
   {
      private readonly string _queryStringKey;
      private readonly Type _type;

      public BindJson(Type type, string queryStringKey)
      {
         _type = type;
         _queryStringKey = queryStringKey;
      }

      public override void OnActionExecuting(ActionExecutingContext actionContext)
      {
         string json = actionContext.HttpContext.Request.Query[_queryStringKey];
         actionContext.ActionArguments[_queryStringKey] = string.IsNullOrEmpty(json) ? null : JsonSerializer.Deserialize(json, _type);
      }
   }
}