﻿using System;
using System.Diagnostics;
using System.IO;

namespace ExternalServiceV3.Models
{
   /// <summary>
   /// Information on the JsonApiServer
   /// </summary>
   public class Info
   {
      public string Message { get { return "ExternalServiceV3.5"; } }

      public string Description { get { return "This supports v3.5 of the External Service API"; } }

      public string ServerTime { get { return DateTime.Now.ToString("dddd, dd MMMM yyyy HH:mm:ss 'GMT'%K"); } }

      public string AssemblyVersion { get { return FileVersionInfo.GetVersionInfo(GetType().Assembly.Location).FileVersion; } }

      public CoreFile CoreFile { get { return new CoreFile(); } }
   }

   public class CoreFile
   {
      public string ManifestModuleName { get { return GetType().Assembly.ManifestModule.Name; } }

      public string CodeBase { get { return GetType().Assembly.CodeBase; } }

      public string Length { get { return new FileInfo(GetType().Assembly.Location).Length + " bytes"; } }

      public string CreationTime { get { return File.GetCreationTime(GetType().Assembly.Location).ToString("dddd, dd MMMM yyyy HH:mm:ss 'GMT'%K"); } }

      public string LastWriteTime { get { return File.GetLastWriteTime(GetType().Assembly.Location).ToString("dddd, dd MMMM yyyy HH:mm:ss 'GMT'%K"); } }
   }
}