﻿using ExternalServiceV3;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace FunctionalTests;

public abstract class BaseTest
{
    protected ServiceProvider ServiceProvider;
      
    [TestInitialize]
    public void SetUp()
    {
        var serviceCollection = new ServiceCollection();
        serviceCollection.AddLogging(cfg => { });
        var config = new ConfigurationBuilder().AddJsonFile("appsettings.json").Build();
        serviceCollection.AddSingleton<IConfiguration>(config);

        serviceCollection.AddSingleton<DataAccess>();
        serviceCollection.AddHttpClient();
        ServiceProvider = serviceCollection.BuildServiceProvider();
    }
      
    [TestCleanup]
    public void CleanUp()
    {
        ServiceProvider.Dispose();
    }
}