using System.Threading.Tasks;
using ExternalServiceV3;
using ExternalServiceV3.Controllers;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace FunctionalTests
{
   [TestClass]
   public class PermissionsControllerTests: BaseTest
   {
      [TestMethod]
      public async Task ReaderSearch_Test()
      {
         var controller = new PermissionsController(ServiceProvider.GetService<ILogger<PermissionsController>>(), ServiceProvider.GetService<DataAccess>());
         var results = await controller.Get("8", "");

         Assert.IsTrue(results.DocExternalKeys.Contains("ValidExternalKey"));
      }

      [TestMethod]
      public async Task ReaderSearch_Failed_Test()
      {
         var controller = new PermissionsController(ServiceProvider.GetService<ILogger<PermissionsController>>(), ServiceProvider.GetService<DataAccess>());
         var results = await controller.Get("Does not exist", "");

         Assert.IsNull(results.DocExternalKeys);
      }
   }
}